//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int    AMAPeriod       = 10;
extern int    AMAPrice        = PRICE_CLOSE;
extern int    Nfast           = 2;
extern int    Nslow           = 30;
extern double GCoeff          = 2;
extern int    PriceFilter     = 5;
extern int    PriceFilterMode = MODE_EMA;
extern double AngleTreshold   = 5;
extern int    AngleBars       = 6;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav"; 


//
//
//
//
//

double kAMAbuffer[];
double kAMAbufferu[];
double kAMAbufferd[];
double wAMAbuffer[];
double diff[];
double slope[];

//
//
//
//
//

double fastend;
double slowend;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,kAMAbufferu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,kAMAbufferd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,kAMAbuffer);
   SetIndexBuffer(3,wAMAbuffer);
   SetIndexBuffer(4,diff);
   SetIndexBuffer(5,slope);
   
   //
   //
   //
   //
   //
   
      fastend   = (2.0 /(Nfast + 1));
      slowend   = (2.0 /(Nslow + 1));
   
   //
   //
   //
   //
   //
   
   IndicatorShortName("Kaufman AMA ("+AMAPeriod+")");
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define Pi 3.141592653589793238462643
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      kAMAbuffer[i]  = iKama(kAMAbuffer,diff,AMAPeriod,AMAPrice,GCoeff,i);
      kAMAbufferu[i] = EMPTY_VALUE;
      kAMAbufferd[i] = EMPTY_VALUE;
      slope[i]       = 0;

         double range  = iATR(NULL,0,AngleBars*20,i);
         double angle  = 0.00;
         double change = kAMAbuffer[i]-kAMAbuffer[i+AngleBars];

         if (range != 0) angle = MathArctan(change/(range*AngleBars))*180.0/Pi;
         if (AngleTreshold>0)
         {
            if (kAMAbuffer[i]>kAMAbuffer[i+1] && angle> AngleTreshold) slope[i] =  1;
            if (kAMAbuffer[i]<kAMAbuffer[i+1] && angle<-AngleTreshold) slope[i] = -1;
         }
         else
         {
            if (kAMAbuffer[i]>kAMAbuffer[i+1]) slope[i] =  1;
            if (kAMAbuffer[i]<kAMAbuffer[i+1]) slope[i] = -1;
         }            
         if (slope[i]== 1) kAMAbufferu[i] = 1;
         if (slope[i]==-1) kAMAbufferd[i] = 1;
   } 
   manageAlerts();      
   return(0);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

double price[];
double iKama(double& ama.buffer[],double& diff.buffer[],int period,int priceType,double gCoeff,int i)
{
   double efratio  = 1.00;
   double AMA      = 0.00;
   if (ArraySize(price)!=Bars) ArrayResize(price,Bars); int r = Bars-i-1;
      price[r]    = iMA(NULL,0,PriceFilter,0,PriceFilterMode,priceType,i);


   if (i > Bars-period) return(price);
   
   //
   //
   //
   //
   //
   
   double smooth;
   double signal;
   double noise;
          signal         = MathAbs(price[r]-price[r-period]);
          diff.buffer[i] = MathAbs(price[r]-price[r-1]);
          for (int k=0;k<period;k++)
                  noise += diff.buffer[i+k];

          //
          //
          //
          //
          //

          if (noise != 0) efratio = signal/noise;
                          smooth  = MathPow(efratio*(fastend-slowend)+slowend,gCoeff);
                          AMA     = ama.buffer[i+1] + smooth*(price[r]-ama.buffer[i+1]);
   //
   //
   //
   //
   //

   return(AMA);          
}


void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] == 1) doAlert(whichBar,"up");
         if (slope[whichBar] ==-1) doAlert(whichBar,"down");         
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol(),TimeToStr(TimeLocal(),TIME_SECONDS)," Kaufman ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Kaufman "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


